#ifndef __QN
#define __QN
#include <iostream.h>
#include <Rational.h>

/*******************************************************************
arithmetic for Q() ---  = N-th root of unity
*******************************************************************/

struct QN {
	// data
	static int N; // N-th root of unity
	static int n; // \phi(N)
	static int *r;    // for computing inverse
	static Rational *(*mat); // for computing inverse
	Rational *a;
	// constructor
	QN(int x = 0);
	QN(QN &x);
	QN(Rational &x);

	~QN();
	// elements
	QN& operator = (QN &x);
	QN& operator = (Rational &x);
	QN& operator = (int x);
	QN  operator + (QN &y);
	QN  operator - (QN &y);
	QN  operator * (QN &y);
	QN  operator * (Rational &y);
	QN  operator / (QN y);
	friend QN& operator + (QN &x); // unary plus
	friend QN  operator - (QN x); // unary minus
	QN& operator *= (QN &y);
	QN& operator *= (Rational &y);
	QN& operator /= (QN  y);
	QN& operator += (QN &y);
	QN& operator -= (QN &y);
	int operator != (QN &y);
	int operator == (QN &y);
	int operator != (int y);
	int operator == (int y);
	void invert();
	friend ostream& operator << (ostream &, QN &);
	friend istream& operator >> (istream &, QN &);
};

int len(QN &x);

QN abs(QN &x);

int sign(QN &x);

void set(int n);
#endif
